<!DOCTYPE html>
<html class="writer-html5" lang="en">
<head>
  <meta charset="utf-8" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>nl2declare.test.utils.test_io &mdash; NL2Declare  documentation</title>
      <link rel="stylesheet" type="text/css" href="../../../../_static/pygments.css" />
      <link rel="stylesheet" type="text/css" href="../../../../_static/css/theme.css" />

  
  <!--[if lt IE 9]>
    <script src="../../../../_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
        <script data-url_root="../../../../" id="documentation_options" src="../../../../_static/documentation_options.js"></script>
        <script src="../../../../_static/jquery.js"></script>
        <script src="../../../../_static/underscore.js"></script>
        <script src="../../../../_static/_sphinx_javascript_frameworks_compat.js"></script>
        <script src="../../../../_static/doctools.js"></script>
    <script src="../../../../_static/js/theme.js"></script>
    <link rel="index" title="Index" href="../../../../genindex.html" />
    <link rel="search" title="Search" href="../../../../search.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >

          
          
          <a href="../../../../index.html" class="icon icon-home">
            NL2Declare
          </a>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" aria-label="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <p class="caption" role="heading"><span class="caption-text">Contents:</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../../../modules.html">nl2declare</a></li>
</ul>

        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../../../index.html">NL2Declare</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="../../../../index.html" class="icon icon-home" aria-label="Home"></a></li>
          <li class="breadcrumb-item"><a href="../../../index.html">Module code</a></li>
          <li class="breadcrumb-item"><a href="../../../nl2declare.html">nl2declare</a></li>
      <li class="breadcrumb-item active">nl2declare.test.utils.test_io</li>
      <li class="wy-breadcrumbs-aside">
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <h1>Source code for nl2declare.test.utils.test_io</h1><div class="highlight"><pre>
<span></span><span class="kn">from</span> <span class="nn">nl2declare.utils.io</span> <span class="kn">import</span> <span class="n">load_cases</span>

<span class="n">__EXPECTED_CASES__</span> <span class="o">=</span> <span class="p">[</span><span class="s1">&#39;A claim should be created, before it can be approved.&#39;</span><span class="p">,</span>
    <span class="s1">&#39;A claim must be created, before it is approved.&#39;</span><span class="p">,</span>
    <span class="s1">&#39;When a claim is created, it may be approved.&#39;</span><span class="p">,</span>
    <span class="s1">&#39;If a claim is created, it can be approved.&#39;</span><span class="p">,</span>
    <span class="s1">&#39;They have to create the claim, before they can approve it.&#39;</span><span class="p">,</span>
    <span class="s1">&#39;Only after a claim is created, it is possible to approve the claim.&#39;</span><span class="p">,</span>
    <span class="s1">&#39;If a claim is approved, then it must have been created first.&#39;</span><span class="p">,</span>
    <span class="s1">&#39;To approve a claim, it should be created first.&#39;</span><span class="p">,</span>
    <span class="s1">&#39;A claim can be approved, after it has been created.&#39;</span><span class="p">,</span>
    <span class="s1">&#39;Approving the claim can happen at anytime, unless it still needs to be created.&#39;</span><span class="p">,</span>
    <span class="s1">&#39;Creation of the claim is required, before it can be approved.&#39;</span><span class="p">,</span>
    <span class="s1">&#39;The creation of the claim is a condition for the approval of the claim.&#39;</span><span class="p">,</span>
    <span class="s1">&#39;Only after the creation of a claim, the approval of the claim is possible.&#39;</span><span class="p">,</span>
    <span class="s1">&#39;When approval of the claim occurs, creation of the claim must have preceded.&#39;</span><span class="p">,</span>
    <span class="s1">&#39;If approval of the claim occurs, then creation of the claim must have been carried out first.&#39;</span><span class="p">,</span>
    <span class="s1">&#39;The approval of the claim requires that the creation of the claim occurs before it.&#39;</span><span class="p">,</span>
    <span class="s1">&#39;The approval of the claim should be preceded by the creation of the claim.&#39;</span><span class="p">,</span>
    <span class="s1">&#39;A claim must be created, before it can be approved or rejected.&#39;</span><span class="p">,</span>
    <span class="s1">&#39;A claim should be approved before it can be paid out.&#39;</span><span class="p">,</span>
    <span class="s1">&#39;Once a claim has been approved, it should eventually be paid out.&#39;</span><span class="p">,</span>
    <span class="s1">&#39;Once a claim has been rejected, it should not be paid out.&#39;</span><span class="p">,</span>
    <span class="s1">&#39;Payout should end the process and therefore exclude everything.&#39;</span><span class="p">,</span>
    <span class="s1">&#39;A case can be closed manually at any time, unless we still need to pay out the claim.&#39;</span><span class="p">,</span>
    <span class="s1">&#39;The case can be managed at the union after it has been created.&#39;</span><span class="p">,</span>
    <span class="s1">&#39;After a case is created, management can and must arrange a meeting between the union case worker and the other case worker.&#39;</span><span class="p">,</span>
    <span class="s1">&#39;After a meeting is arranged it must be held.&#39;</span><span class="p">,</span>
    <span class="s1">&#39;The case worker should enter metadata on the case, inform about when he is available for participating in a meeting and then submit the case.&#39;</span><span class="p">,</span>
    <span class="s1">&#39;When a case is submitted it may get a local id at the union, but it should also subsequently be assigned a case id in LO.&#39;</span><span class="p">,</span>
    <span class="s1">&#39;When a case is submitted, LO should eventually propose dates.&#39;</span><span class="p">,</span>
    <span class="s1">&#39;Only after LO has assigned its case id it is possible to manage the case and for LO to propose dates.&#39;</span><span class="p">,</span>
    <span class="s1">&#39;Once a date has been agreed upon a meeting should eventually be held.&#39;</span><span class="p">,</span>
    <span class="s1">&#39;Every process instance starts by examining a patient.&#39;</span><span class="p">,</span>
    <span class="s1">&#39;If an x-ray is taken, then the x-ray risk must be checked before it&#39;</span><span class="p">,</span>
    <span class="s1">&#39;Performing a reposition, applying a cast and performing surgery require that x-rays are performed before.&#39;</span><span class="p">,</span>
    <span class="s1">&#39;If a surgery is performed, then prescription of rehabilitation occurs eventually after it.&#39;</span><span class="p">,</span>
    <span class="s1">&#39;After a cast is applied, eventually the cast is removed and vice versa, before every removal of a cast, a cast must be applied.&#39;</span><span class="p">,</span>
    <span class="s1">&#39;The process begins with the booking of the ticket&#39;</span><span class="p">,</span>
    <span class="s1">&#39;Personal information of passengers can be provided after the booking of the ticket&#39;</span><span class="p">,</span>
    <span class="s1">&#39;The payment of the ticket triggers the completion of the booking phase.&#39;</span><span class="p">,</span>
    <span class="s1">&#39;The payment of the ticket is eventually followed by the actual transfer of money&#39;</span><span class="p">,</span>
    <span class="s1">&#39;As long as the Check-in of the flight does not take place, the customers can still modify the provided data to change&#39;</span><span class="p">,</span>
    <span class="s1">&#39;After check-in of the flight, only the cancellation is admitted&#39;</span><span class="p">,</span>
    <span class="s1">&#39;The process starts when an invoice is received by the administration department.&#39;</span><span class="p">,</span>
    <span class="s1">&#39;If they decide that the invoice appears legit then they enter all relevant data into the system&#39;</span><span class="p">,</span>
    <span class="s1">&#39;When all necessary approvals have been received the invoice can be paid.&#39;</span><span class="p">,</span>
    <span class="s1">&#39;Once payment is confirmed, the invoice case should be closed.&#39;</span><span class="p">,</span>
    <span class="s1">&#39;The receipt of an invoice is required before the administration department can enter data or scan the invoice.&#39;</span><span class="p">,</span>
    <span class="s1">&#39;Enter data is required before any approval can be given.&#39;</span><span class="p">,</span>
    <span class="s1">&#39;Finally, we have to pay the invoice before we can confirm payment.&#39;</span><span class="p">,</span>
    <span class="s1">&#39;If a request is sent, then a proposal is expected to be prepared afterwards&#39;</span><span class="p">,</span>
    <span class="s1">&#39;A confirmation is supposed to be mandatorily given after the proposal, and vice-versa any proposal is expected to precede a confirmation &#39;</span><span class="p">,</span>
    <span class="s1">&#39;Every process instance has to start by registering client data&#39;</span><span class="p">,</span>
    <span class="s1">&#39;Every provided room service must be billed.&#39;</span><span class="p">,</span>
    <span class="s1">&#39;Every provided laundry service must be billed&#39;</span><span class="p">,</span>
    <span class="s1">&#39;When the client leaves, the bill must be charged&#39;</span><span class="p">,</span>
    <span class="s1">&#39;The Police Report related to the car accident is searched within the Police Report database and put in a file together with the Claim Documentation.&#39;</span><span class="p">,</span>
    <span class="s1">&#39;A customer brings in a defective computer and the manager analyzes the defect and gives back an invoice.&#39;</span><span class="p">,</span>
    <span class="s1">&#39;After each of these activities, the proper system functionality is tested.&#39;</span><span class="p">,</span>
    <span class="s1">&#39;If an error is detected, another arbitrary repair activity is executed, otherwise the repair is finished.&#39;</span><span class="p">,</span>
    <span class="s1">&#39;After a claim is registered, it is examined by a claims officer.&#39;</span><span class="p">,</span>
    <span class="s1">&#39;This recommendation is then checked by a senior claims officer who may mark the claim as OK or Not OK.&#39;</span><span class="p">,</span>
    <span class="s1">&#39;If the claim is marked as Not OK, it is sent back to the claims officer and the recommendation is repeated.&#39;</span><span class="p">,</span>
    <span class="s1">&#39;If the claim is OK, the claim handling process proceeds.&#39;</span><span class="p">,</span>
    <span class="s1">&#39;The process of buying new hardware is started as soon as a request for new hardware is received by the IT department.&#39;</span><span class="p">,</span>
    <span class="s1">&#39;The next step is for the IT department to analyse the request and either approve or deny it.&#39;</span><span class="p">,</span>
    <span class="s1">&#39;If it is denied, the employee is informed via email about the denial and the process is ended.&#39;</span><span class="p">,</span>
    <span class="s1">&#39;However, if the request is approved it is edited and completed.&#39;</span><span class="p">,</span>
    <span class="s1">&#39;Once this offer is received, a form is filled in and sent to the management.&#39;</span><span class="p">,</span>
    <span class="s1">&#39;The management then analyses the request and decides if it is approved or not.&#39;</span><span class="p">,</span>
    <span class="s1">&#39;When this is accepted and the financial resources are found, the hardware is received by the IT department.&#39;</span><span class="p">,</span>
    <span class="s1">&#39;After which the financial department will take care of the invoice and the processes is ended.&#39;</span><span class="p">,</span>
    <span class="s1">&#39;In the scenario where the management does not approve the request, it can send the request back to the IT department for rework, then the IT department has to go back to editing and completing a request.&#39;</span><span class="p">,</span> <span class="s1">&#39;If the management does not approve the request, it can also decide to deny the request after which the process is ended.&#39;</span><span class="p">,</span>
    <span class="s1">&#39;The loan approval process starts by receiving a customer request for a loan amount.&#39;</span><span class="p">,</span>
    <span class="s1">&#39;If the customer needs further review or the loan amount is for </span><span class="se">\\</span><span class="s1">$10,000 or more, the request is sent to the approver Web service.&#39;</span><span class="p">,</span>
    <span class="s1">&#39;The process of an Office Supply Request starts when any employee of the organization submits an office supply request.&#39;</span><span class="p">,</span>
    <span class="s1">&#39;Once the requirement is registered, the request is received by the immediate supervisor of the employee requesting the office supplies.&#39;</span><span class="p">,</span>
    <span class="s1">&#39;If the request is rejected, the process will end.&#39;</span><span class="p">,</span>
    <span class="s1">&#39;If the request is asked to make a change, then it is returned to the petitioner who can review the comments for the change request.&#39;</span><span class="p">,</span>
    <span class="s1">&#39;If the request is approved, it will go to the purchase department that will be in charge of making quotations (using a subprocess) and select a vendor.&#39;</span><span class="p">,</span>
    <span class="s1">&#39;After a vendor is selected and confirmed, the system will generate and send a purchase order and wait for the product to be delivered and the invoice received.&#39;</span><span class="p">,</span>
    <span class="s1">&#39;In any of the cases, approval, rejection or change required the system will send the user a notification.&#39;</span><span class="p">,</span>
    <span class="s1">&#39;The process starts when any employee of the organization submits a vacation request.&#39;</span><span class="p">,</span>
    <span class="s1">&#39;Once the requirement is registered, the request is received by the immediate supervisor of the employee requesting the vacation.&#39;</span><span class="p">,</span>
    <span class="s1">&#39;If the request is rejected, the application is returned to the applicant/employee who can review the rejection reasons.&#39;</span><span class="p">,</span>
    <span class="s1">&#39;If the request is approved, a notification is generated to the Human Resources Representative, who must complete the respective management procedures.&#39;</span><span class="p">,</span>
    <span class="s1">&#39;The process starts by reviewing the order.&#39;</span><span class="p">,</span> <span class="s1">&#39;If something is missing, the staff has to inform customer about a potential delay and order the missing products.&#39;</span><span class="p">,</span>
    <span class="s1">&#39;After waiting an average of x days for the delivery, the staff should check again if all products are on store.&#39;</span><span class="p">,</span>
    <span class="s1">&#39;The courier company informs the client about a potential delay until there are enough human resources to process the delivery.&#39;</span><span class="p">,</span>
    <span class="s1">&#39;Once the driver delivers the package, she should update the system so all stakeholders are notified.&#39;</span><span class="p">,</span>
    <span class="s1">&#39;Whenever the sales department receives an order, a new process instance is created.&#39;</span><span class="p">,</span>
    <span class="s1">&#39;If the storehouse has successfully reserved or back-ordered every item of the part list and the preparation activity has finished, the engineering department assembles the bicycle.&#39;</span><span class="p">,</span>
    <span class="s1">&#39;Afterwards, the sales department ships the bicycle to the customer and finishes the process instance.&#39;</span><span class="p">,</span>
    <span class="s1">&#39;If the requested amount is lower or equal to 1M$, the company assess the risk of the credit.&#39;</span><span class="p">,</span>
    <span class="s1">&#39;After the approval request, the credit could be accepted or rejected&#39;</span><span class="p">,</span>
    <span class="s1">&#39;If the requested amount is greater than 1M$, an approval must be requested.&#39;</span><span class="p">,</span>
    <span class="s1">&#39;If the requested amount is lower or equal to 1M$, the company assess the risk of the credit.&#39;</span><span class="p">,</span>
    <span class="s1">&#39;As soon as an employee files an expense report, the process is started.&#39;</span><span class="p">,</span>
    <span class="s1">&#39;Once the expense report is received, a check is performed to make sure the employee has an account.&#39;</span><span class="p">,</span>
    <span class="s1">&#39;If this check does not take place within 28 days, the process is stopped and the employee is sent a submit email.&#39;</span><span class="p">,</span>
    <span class="s2">&quot;First, the supervisor approves within 7 days, this will result in the deposit of the reimbursement directly to the employee&#39;s bank account.&quot;</span><span class="p">,</span>
    <span class="s1">&#39;Second, the supervisor rejects within 7 days, as a result the employee receives a notification through email that the request has been rejected.&#39;</span><span class="p">,</span>
    <span class="s1">&#39;Third, if it takes the supervisor more than 7 days to respond, an email is sent to the employee informing him/her that the approval is in progress and the part of the processes after a supervisor is asked for approval is repeated.&#39;</span>
<span class="p">]</span>

<span class="c1">#def test_load_cases():</span>
    <span class="c1"># Test normal case:</span>
    <span class="c1">#assert load_cases(&#39;input/datacollectioncsv&#39;) == __EXPECTED_CASES__</span>
<span class="c1"># not working because expected cases need to be updated</span>

<div class="viewcode-block" id="test_load_cases_with_missing_file"><a class="viewcode-back" href="../../../../nl2declare.test.utils.html#nl2declare.test.utils.test_io.test_load_cases_with_missing_file">[docs]</a><span class="k">def</span> <span class="nf">test_load_cases_with_missing_file</span><span class="p">():</span>
    <span class="c1"># Error due to missing file:</span>
    <span class="k">assert</span> <span class="n">load_cases</span><span class="p">(</span><span class="s1">&#39;not_a_file.csv&#39;</span><span class="p">)</span> <span class="ow">is</span> <span class="kc">None</span></div>

<div class="viewcode-block" id="test_load_cases_with_missing_header"><a class="viewcode-back" href="../../../../nl2declare.test.utils.html#nl2declare.test.utils.test_io.test_load_cases_with_missing_header">[docs]</a><span class="k">def</span> <span class="nf">test_load_cases_with_missing_header</span><span class="p">():</span>
    <span class="c1"># Error due to missing header:</span>
    <span class="k">assert</span> <span class="n">load_cases</span><span class="p">(</span><span class="s1">&#39;test/utils/missing_header.csv&#39;</span><span class="p">)</span> <span class="ow">is</span> <span class="kc">None</span></div>

<span class="c1"># def test_load_cases_with_missing_field():</span>
<span class="c1">#     # Empty due to missing fields in a the only row, but no error:</span>
<span class="c1">#     assert load_cases(&#39;test/utils/no_content.csv&#39;) == []</span>
</pre></div>

           </div>
          </div>
          <footer>

  <hr/>

  <div role="contentinfo">
    <p>&#169; Copyright 2024, Pia Halkour, Marc Ludevid Wulf, Julian Kofferath.</p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>